<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="ru-RU">
<head profile="http://gmpg.org/xfn/11">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>OGame babysitter setup</title>
<link rel="stylesheet" href="style.css" type="text/css" media="screen" />
</head>
<body>
<?php

// подключение либов
$mylib_dir = dirname(__FILE__) . '/';
require_once $mylib_dir . 's_http.php';
require_once $mylib_dir . 'searcher.php';
require_once $mylib_dir . 'settings.php';
require_once $mylib_dir . 'cm.php';

$mark = empty($_POST['mark']) ? '' : $_POST['mark'];
$st = new settings('auth.txt');

//планеты уже есть какие то, значит покажем полную страницу настроек
if (!empty($st->S['planets']) && empty($mark)) $mark = 'setup';
//принудительно читаем данные заново
if (!empty($_GET['reset'])) $mark = 'reset';

switch($mark) {
case 'setup-save':
    //сохраняем данные из формы
    //авторизация
    $ud = $st->S;
    $ud['login'] = trim($_POST['login']);
    $ud['password'] = empty($_POST['password']) ? $st->getV('password') : $_POST['password'];
    $ud['uniUrl'] = trim($_POST['uniUrl']);
    $ud['report-mail'] = trim($_POST['report-mail']);
    
    //техи
    $ud['tech']['jet'] = intval($_POST['tech-jet']) + 0; 
    $ud['tech']['pulse'] = intval($_POST['tech-pulse']) + 0; 
    $ud['tech']['grav'] = intval($_POST['tech-grav']) + 0; 
    
    //тайминг
    $crontime = intval($_POST['crontime']) + 0;
    if ($crontime < 1) $crontime = 1;
    if ($crontime > 10) $crontime = 10;
    $ud['time']['crontime'] = $crontime;

    $scanMin = intval($_POST['scanmin']) + 0;
    if ($scanMin < 2) $scanMin = 2;
    $scanMax = intval($_POST['scanmax']) + 0;
    if ($scanMax > 40) $scanMax = 40;
    if ($scanMin > $scanMax) {
        $scanMin = 10;
        $scanMax = 25;
    }
    $ud['time']['scanmin'] = $scanMin;
    $ud['time']['scanmax'] = $scanMax;
    
    $scanMin = intval($_POST['scanBattleMin']) + 0;
    if ($scanMin < 1) $scanMin = 1;
    $scanMax = intval($_POST['scanBattleMax']) + 0;
    if ($scanMax > 10) $scanMax = 10;
    if ($scanMin > $scanMax) {
        $scanMin = 2;
        $scanMax = 5;
    }
    $ud['time']['scanBattleMin'] = $scanMin;
    $ud['time']['scanBattleMax'] = $scanMax;
   
    $sensedelta = floatval($_POST['sensedelta']) + 0;
    if ($sensedelta < 0.5) $sensedelta = 0.5;
    $ud['time']['sensedelta'] = $sensedelta;    
    
    $ud['time']['noReturnTime'] = intval($_POST['noReturnTime']) + 0;
    $ud['time']['tickerMethod'] = $_POST['tickerMethod'];
    
    //чтение данных по планетам
    $i = 1;
    while (isset($_POST["name_$i"])) {
        if (!empty($_POST["del_$i"])) {
            unset($ud['planets'][$_POST["name_$i"]]);
            $i++;
            continue;
        }
        $planet = array(
            $_POST["coords_$i"],
            $_POST["id_$i"],
            'norefuge' => !isset($_POST["bot_$i"]));
        if (!empty($_POST["evacDest_$i"]) && $_POST["evacMission_$i"] > 0) {
            $planet['refugeVars'] = array(
                'to' => $_POST["evacDest_$i"],
                'mission' => $_POST["evacMission_$i"],
            );
        }
        $ud['planets'][$_POST["name_$i"]] = $planet;
        $i++;        
    }
    $st->S = $ud;
    $st->store();
    echo "<div class=error>Данные сохранены! <a href=\"index.php\">Перейти к статусной странице</a></div>";
case 'setup':
    $ud = $st->S;
    if (empty($ud['time']['crontime'])) {
        $ud['time'] = array('crontime' => 1, 'sensedelta' => 0.5, 'noReturnTime' => 30, 'tickerMethod' => 'cron',
            'scanBattleMin' => 2, 'scanBattleMax' => 5, 'scanmin' => 10, 'scanmax' => 25);
    }

    if (empty($ud['tech']))
        $ud['tech'] = array('jet' => 0, 'pulse' => 0, 'grav' => 0);

    error_reporting(E_ERROR | E_PARSE);
    
?>
<b>Все параметры на одной странице.</b><br />Вы можете пройти заново процедуру автоматического прочтения данных по планетам, для этого нужно <a href="?reset=1">удалить текущие настройки</a>.
<form method="post">
<table width="950">
<tr><th colspan="2">Подключение</th></tr>
<tr><td><b>Логин:</b></td><td><input type="text" name="login" value="<?=htmlspecialchars($ud['login'])?>" /></td></tr>
<tr><td>Пароль:</td><td><input type="text" name="password" value="" />
    Введите новый пароль, если желаете его поменять.
</td></tr>
<tr><td>Емайл для отчетов:</td><td><input type="text" name="report-mail" value="<?=htmlspecialchars($ud['report-mail'])?>" /></td></tr>
<tr><td><b>Сервер:</b></td><td><input name="uniUrl" type="text" value="<?=htmlspecialchars($ud['uniUrl'])?>" /></td></tr>

<tr><th colspan="2">Планеты</th></tr>
<tr><td colspan="2">
    <table>
    <tr><th>№</th><th>Название</th><th>Коорд.</th><th>Код</th><th>Режим<br />няньки</th>
        <th>Куда<br >эвакуировать *</th><th>Тип миссии *</th>
        <th>Удалить</th>
    </tr>
<?
    $i = 0;
    foreach($ud['planets'] as $k => $v) {
?>
    <tr>
        <td><?=++$i?>.</td>
        <td><input type="text" value="<?=htmlspecialchars($k)?>" name="name_<?=$i?>" readonly /></td>
        <td><input type="text" size="10" value="<?=htmlspecialchars($v[0])?>" name="coords_<?=$i?>" /></td>
        <td><input type="text" size="10" value="<?=htmlspecialchars($v[1])?>" name="id_<?=$i?>" /></td>
        <td align="center"><input type="checkbox" value="1" name="bot_<?=$i?>" <?=$v['norefuge'] ? '' : 'checked'?> /></td>
        <td><input type="text" size="10" value="<?=htmlspecialchars($v['refugeVars']['to'])?>" name="evacDest_<?=$i?>" /></td>
        <td><select name="evacMission_<?=$i?>">
                <option value="-1">--</option>
                <option value="3" <?=$v['refugeVars']['mission'] == 3 ? 'selected' : ''?>>Транспорт</option>
                <option value="4" <?=$v['refugeVars']['mission'] == 4 ? 'selected' : ''?>>Оставить</option>
            </select>
        </td>
        <td align="center"><input type="checkbox" value="1" name="del_<?=$i?>" /></td>
    </tr>
<?
    }
?>
    </table>
    <small>
        * - можно задать место эвакуации вручную. Укажите координаты (x:xx:xx) и тип миссии. Если планета не контролируется вами, 
    то миссию "оставить" не выбирайте! Ручные установки нужны в тех случаях, когда у вас всего одна планета, или данная планета 
    находится слишком далеко от остальных (например, в другой галактике). Если нет ручных настроек, то автоматически при эвакуации выбирается 
    одна из ваших ближайших планет.</small>
</td></tr>
<tr><th colspan="2">Техи двигателей</th></tr>
<tr><td colspan="2">Не сильно принципиально для расчетов, но для большей точности стоит вводить актуальные значения<br />
    Реак. дв. : <input size="5" type="text" name="tech-jet" value="<?=htmlspecialchars($ud['tech']['jet'])?>" /> 
    Импл. дв. : <input size="5" type="text" name="tech-pulse" value="<?=htmlspecialchars($ud['tech']['pulse'])?>" /> 
    Грав. дв. : <input size="5" type="text" name="tech-grav" value="<?=htmlspecialchars($ud['tech']['grav'])?>" /> 
</td></tr>
<tr><th colspan="2">Тайминг</th></tr>
<tr><td colspan="2">
    <table>
    <tr><td>Период таймера, мин:</td><td><input size="5" type="text" name="crontime" value="<?=htmlspecialchars($ud['time']['crontime'])?>" />
            рекомендуемое значение в диапазоне 1-5 мин и строго меньше, чем максимальный период боевого сканирования (это регулярное значение времени, 
            через каждый промежуметок которого вызывается нянька)</td></tr>
    <tr><td>Перекрытие по сканированию, мин:</td><td><input size="5" type="text" name="sensedelta" value="<?=htmlspecialchars($ud['time']['sensedelta'])?>" /> значения от 0.25 до 1 мин.
    </td></tr>
    <tr><td>Период времени между сканированиями, мин:</td>
        <td>от <input size="5" type="text" name="scanmin" value="<?=htmlspecialchars($ud['time']['scanmin'])?>" /> 
            до <input size="5" type="text" name="scanmax" value="<?=htmlspecialchars($ud['time']['scanmax'])?>" /> 
            рекомендуемое значение диапазон 10-25 мин - для неускоренных вселенных, никакого риска. Значения выше 40 мин - это уже зона серьёзного риска.</td></tr>
    <tr><td>Период времени между сканированиями во время угрозы атаки и возврата флота, мин:</td>
        <td>от <input size="5" type="text" name="scanBattleMin" value="<?=htmlspecialchars($ud['time']['scanBattleMin'])?>" /> 
            до <input size="5" type="text" name="scanBattleMax" value="<?=htmlspecialchars($ud['time']['scanBattleMax'])?>" /> 
            рекомендуемый интервал - 3-5 мин</td></tr>
    <tr><td>Период не возврата, мин:</td><td><input size="5" type="text" name="noReturnTime" value="<?=htmlspecialchars($ud['time']['noReturnTime'])?>" />
        если не удалось вернуть флот в течении этого времени, то отзыв флота не производится вообще (т.е. эвакуируемый флот выполняет свою миссию). 
        Отзыв флота производится только в том случае, если возврат будет безопасен при данных параметрах автоматизации.
    </td></tr>
    <tr><td>Тип вызова:</td><td>
        <select name="tickerMethod">
            <option value="cron" <?=$ud['time']['tickerMethod'] == 'cron' ? 'selected' : ''?>>Утилита unix CRON *</option>
            <option value="localjs" <?=$ud['time']['tickerMethod'] == 'localjs' ? 'selected' : ''?>>Методами JS, локально **</option>
        </select>
        </td>
    </tr>
    </table>
    <p><small>
        * - CRON unix, планировщик задач Windows или любая другая утилита, позволяющая выполнять приложения по расписанию. При этом
    нужно настроить утилиту так, чтобы она вызывала скрипт index.php (через http://) с параметрами GET = "auto=1". Например, если вы 
    настроили у себя какой то виртуальный хостинг c именем домена "ogame-babysistter.local" и выложили туда прямо в корень содердимое 
    архива няньки, то нужно будет иницировать по расписанию чтение веб-страницы с url = "http://ogame-babysistter.local/index.php?auto=1". 
    Период вызова должен совпадать с введенным значением в поле "Период сканирования".</small></p>
    <p><small>
        ** - если вы выбрали метод JS, то скрипт будет сам себя вызывать методами js с заданным периодом. Для этого у вас должна  
    в браузере быть открыта страница index.php данного проекта и включен РЕЖИМ ОХРАНЫ.</small></p>
    <p>
    Когда нянька работает локально, помните : если у вас пропал интернет или заглючил компьютер, то нянька не сможет выполнить свои 
    функции. Компьютер должен быть включен (находится не в спящем режиме!).
    </p>
</td></tr>
<tr><td colspan="2" align="center"><input type="submit" value="Сохранить"/></td></tr>
</table>
<input type="hidden" name="mark" value="setup-save" />
</form>    
<?
    break;
case 'auth':
    if (!$_POST['uniUrl'] || empty($_POST['login'])) {
        echo "<div class=\"error\">Надо указать сервер и логин с паролем!</div>";
    } else {
        //пробуем подключиться для сбора информации по планетам
        //подключение, авторизация, сбор информации
        $ud = array(
            'login' => trim($_POST['login']),
            'password' => empty($_POST['password']) ? $st->getV('password') : $_POST['password'],
            'uniUrl' => $_POST['uniUrl'],
            'planets' => array(),
            'report-mail' => $_POST['report-mail'],
            'time' => array('tickerMethod' => 'localjs'),
            'tech' => array('jet' => 0, 'pulse' => 0, 'grav' => 0)
            );
        $CM = new fleetCommander($ud, false);
        //авторизация
        $CM->http = new s_http();
        $CM->http->init();
        $CM->ready = $CM->auth();
        if ($CM->ready) {
            $planetDo = $CM->planets;
            //так как для одной планеты мы код CP не получили, то надо немного схитрить и заставить систему все таки выдать нам недостающий код.
            foreach ($planetDo as $k => $v) {
                if (empty($v[2])) {
                    $cp = '65345' . rand(100, 999);
                    $CM->http->get("http://{$CM->ud['uniUrl']}/game/index.php?page=overview&session={$CM->sessionCode}&cp=$cp");
                    if (preg_match('@[&]cp=([\d]+)@', $CM->http->currentPage(), $m)) $v[2] = $m[1];
                }
                $ud['planets'][$k] = array($v[0], $v[2]);
            }

            //сохраняем данные
            $st->S = $ud;
            $st->store();
            
            echo "Получены данные о ваших планетах. ВАЖНО! Ваши планеты дожны иметь уникальные названия. Если это не так, 
            сейчас как раз самый подходящий момент их переименовать. Во избежении проблем с кодировками, предпочтительны
            названия, выполненные латиницей.
                <table>
                    <tr><th>Название</th><th>Координаты</th><th>Код</th></tr>
            ";
            foreach ($ud['planets'] as $k => $v) {
                echo "<tr><td>$k</td><td align=\"center\">$v[0]</td><td align=\"center\">$v[1]</td></tr>";
            }
            echo '</table><form method="post">
                <input type="hidden" name="mark" value="setup" />
                <input type="submit" value="Далее..." />
            </form>';
            break;
        } else {
            echo "<div class=\"error\">Не удалось подключиться с указанными реквизитами !</div>";
        }
    }
case 'reset':
default:

    $serv = $st->getV('uniUrl');
?>
Введите реквизиты подключения к игровому серверу Ogame.
<form method="post" action="setup.php">
<table>
<tr><td><b>Логин:</b></td><td><input type="text" name="login" value="<?=htmlspecialchars($st->getV('login'))?>" /></td></tr>
<tr><td>Пароль:</td><td><input type="text" name="password" value="" /> 
<?
    $pass = $st->getV('password');
    if (!empty($pass)) echo " Пароль уже установлен, введите новый для смены пароля.";
?>
</td></tr>
<tr><td>Емайл для отчетов:</td><td><input type="text" name="report-mail" value="<?=htmlspecialchars($st->getV('report-mail'))?>" /></td></tr>
<tr><td><b>Сервер:</b></td><td>
<select name="uniUrl">
    <option value="" >--надо выбрать сервер--</option> 
    <option value="uni101.ogame.ru" <?=$serv == 'uni101.ogame.ru' ? 'selected' : ''?>>Andromeda</option> 
    <option value="uni102.ogame.ru" <?=$serv == 'uni102.ogame.ru' ? 'selected' : ''?>>Barym</option> 
    <option value="uni103.ogame.ru" <?=$serv == 'uni103.ogame.ru' ? 'selected' : ''?>>Capella</option> 
    <option value="uni104.ogame.ru" <?=$serv == 'uni104.ogame.ru' ? 'selected' : ''?>>Draco</option> 
    <option value="uni1.ogame.ru"   <?=$serv == 'uni1.ogame.ru' ? 'selected' : ''?>>1. Вселенная</option> 
    <option value="uni2.ogame.ru"   <?=$serv == 'uni2.ogame.ru' ? 'selected' : ''?>>2. Вселенная</option> 
    <option value="uni3.ogame.ru"   <?=$serv == 'uni3.ogame.ru' ? 'selected' : ''?>>3. Вселенная</option> 
    <option value="uni4.ogame.ru"   <?=$serv == 'uni4.ogame.ru' ? 'selected' : ''?>>4. Вселенная</option> 
    <option value="uni5.ogame.ru"   <?=$serv == 'uni5.ogame.ru' ? 'selected' : ''?>>5. Вселенная</option> 
    <option value="uni6.ogame.ru"   <?=$serv == 'uni6.ogame.ru' ? 'selected' : ''?>>6. Вселенная</option> 
    <option value="uni7.ogame.ru"   <?=$serv == 'uni7.ogame.ru' ? 'selected' : ''?>>7. Вселенная</option> 
    <option value="uni8.ogame.ru"   <?=$serv == 'uni8.ogame.ru' ? 'selected' : ''?>>8. Вселенная</option> 
    <option value="uni9.ogame.ru"   <?=$serv == 'uni9.ogame.ru' ? 'selected' : ''?>>9. Вселенная</option> 
    <option value="uni10.ogame.ru"  <?=$serv == 'uni10.ogame.ru' ? 'selected' : ''?>>10. Вселенная</option> 
    <option value="uni11.ogame.ru"  <?=$serv == 'uni11.ogame.ru' ? 'selected' : ''?>>11. Вселенная</option> 
    <option value="uni12.ogame.ru"  <?=$serv == 'uni12.ogame.ru' ? 'selected' : ''?>>12. Вселенная</option> 
    <option value="uni13.ogame.ru"  <?=$serv == 'uni13.ogame.ru' ? 'selected' : ''?>>13. Вселенная</option> 
    <option value="uni14.ogame.ru"  <?=$serv == 'uni14.ogame.ru' ? 'selected' : ''?>>14. Вселенная</option> 
    <option value="uni15.ogame.ru"  <?=$serv == 'uni15.ogame.ru' ? 'selected' : ''?>>15. Вселенная</option> 
    <option value="uni16.ogame.ru"  <?=$serv == 'uni16.ogame.ru' ? 'selected' : ''?>>16. Вселенная</option> 
    <option value="uni17.ogame.ru"  <?=$serv == 'uni17.ogame.ru' ? 'selected' : ''?>>17. Вселенная</option> 
    <option value="uni18.ogame.ru"  <?=$serv == 'uni18.ogame.ru' ? 'selected' : ''?>>18. Вселенная</option> 
    <option value="uni19.ogame.ru"  <?=$serv == 'uni19.ogame.ru' ? 'selected' : ''?>>19. Вселенная</option> 
</select>
</td></tr>
<tr><td>&nbsp;</td><td><input type="submit" value="Сохранить"/></td></tr>
<input type="hidden" name="mark" value="auth" />
</table>
</form>
<?php
    break;
}
?>

<div class="credits">
    Нянька для Ogame - ваш спокойный сон уже сегодня. <a href="http://shra.ru/category/gamer/ogame/">Сделано shra.</a> V.03 (2010)
</div>
</body>
</html>