<?php

class settings {
    var $S = array(); 
    var $filename = '';

    function setV($name, $value) {
        $S[$name] = $value;
    }

    function getV($name) {
        if (isset($this->S[$name])) return $this->S[$name];
        else return false;
    }
    
    function settings($filename = 'settings.txt', $default = array()) {
        $this->filename = dirname(__FILE__) . '/' . $filename;
        $fp = fopen($this->filename, 'a+');
        fseek($fp, 0);
        if (filesize($this->filename)) 
            $str = unserialize(fread($fp, filesize($this->filename)));
        else
            $str = false;
        if (empty($str)) {
            $this->S = $default;
        } else {
            $this->S = $str;
        }
        fclose($fp);
    }
    
    function store() {
        $fp = fopen($this->filename, 'w+');
        $str = serialize($this->S);
        fwrite($fp, $str);
        fclose($fp);
    }
}